=== debian/watch ===
version=4

opts="filenamemangle=s%.*/rocm-@ANY_VERSION@%@PACKAGE@-$1.tar.gz%, searchmode=plain, repack, repacksuffix=+ds, dversionmangle=s/[~+](?:dfsg|ds)[0-9]*//g" \
      https://api.github.com/repos/ROCm/amdsmi/tags?per_page=100 \
      https://api.github.com/repos/ROCm/amdsmi/tarball/refs/tags/rocm-@ANY_VERSION@
