=== debian/changelog ===
amdsmi (6.1.2+ds-2) unstable; urgency=medium

  [Cordell Bloor]
  * Upload to unstable.
  * Add self to uploaders.
  * Add d/p/0006-fix-bdf-regex.patch to fix SyntaxWarning in BDF parsing.
    (Closes: #1095708)
  * Update debian copyright for 2025.
  * Update standards version to 4.7.2. No changes required.

  [Xuanteng Huang]
  * Add lintian override rules to suppress false positive warning on
    XBSC-Comment in d/control.
  * Remove unnecessary executable permissions from Python sources.

 -- Cordell Bloor <cgmb@slerp.xyz>  Mon, 07 Apr 2025 17:08:23 -0600

amdsmi (6.1.2+ds-1) experimental; urgency=medium

  * Initial release (Closes: #1076241)

 -- Xuanteng Huang <xuanteng.huang@outlook.com>  Fri, 02 Aug 2024 23:16:52 +0200
